<template>
    <div class="card shadow mb-4">
        <div
            class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between"
        >
            <h6 class="m-0 font-weight-bold text-primary text-capitalize">
                <router-link
                    :event="disabled ? '' : 'click'"
                    :to="{
                        name: 'LeaveShow',
                        params: { id: dataObject.id }
                    }"
                    >{{ dataObject.description }}</router-link
                >
            </h6>
            <div
                class="dropdown no-arrow"
                v-show="!disabled || approvable || cancellable || deletable"
            >
                <a
                    class="dropdown-toggle"
                    href="#"
                    role="button"
                    id="dropdownMenuLink"
                    data-toggle="dropdown"
                    aria-haspopup="true"
                    aria-expanded="false"
                >
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
                <div
                    class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                    aria-labelledby="dropdownMenuLink"
                >
                    <a
                        class="dropdown-item text-success"
                        v-show="!disabled || approvable"
                        @click="onApprove"
                        >Approve</a
                    >
                    <a
                        class="dropdown-item text-secondary"
                        v-show="!disabled || cancellable"
                        @click="onCancel"
                        >Cancel</a
                    >
                    <a
                        class="dropdown-item text-danger"
                        v-show="!disabled || deletable"
                        @click="onDelete"
                        >Delete</a
                    >
                </div>
            </div>
        </div>
        <div class="card-body px-5">
            <div class="row align-items-center text-right">
                <div class="col-12 col-md-2 text-center">
                    <a :href="this.defaultImage" data-fancybox>
                        <img
                            :src="this.defaultImage"
                            class="img-thumbnail"
                            width="100"
                            alt="Medical Certificate"
                        />
                    </a>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">User</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{ dataObject.user ? dataObject.user.full_name : "NA" }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Type</div>
                    <div class="h5 mb-0 text-gray-800 text-capitalize">
                        {{
                            dataObject.classifier_type
                                ? dataObject.classifier_type.name
                                : "NA"
                        }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Leave Start</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{ dataObject.start_at ? dataObject.start_at : "NA" }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Leave End</div>
                    <div class="h5 mb-0 text-gray-800">
                        {{ dataObject.end_at ? dataObject.end_at : "NA" }}
                    </div>
                </div>
                <div class="col-12 col-md-2 mb-3 m-md-0 border-right">
                    <div class="text-xs text-uppercase mb-1">Status</div>
                    <div class="h5 mb-0 text-gray-800 text-capitalize">
                        {{
                            dataObject.classifier_status
                                ? dataObject.classifier_status.name
                                : "NA"
                        }}
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import Swal from "sweetalert2";
export default {
    components: {},
    props: ["object", "disabled", "approvable", "cancellable", "deletable"],
    data() {
        return {
            dataObject: {}
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            this.dataObject = this.object;
        },
        getObject() {
            return axios
                .get("/api/leave/get/" + this.dataObject.id)
                .then(res => {
                    this.dataObject = res.data;
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onApprove() {
            axios
                .get("/api/leave/" + this.dataObject.id + "/approval", {
                    params: {
                        command: 1
                    }
                })
                .then(res => {
                    this.getObject();
                })
                .catch(err => {
                    console.log(err.message);
                })
                .then(res => {
                    this.isDisabledButton = false;
                });
        },
        onCancel() {
            axios
                .get("/api/leave/" + this.dataObject.id + "/approval", {
                    params: {
                        command: 2
                    }
                })
                .then(res => {
                    this.getObject();
                })
                .catch(err => {
                    console.log(err.message);
                })
                .then(res => {
                    this.isDisabledButton = false;
                });
        },
        onDelete() {
            Swal.fire({
                title: "Are you sure?",
                text: "You won't be able to revert this!",
                icon: "warning",
                showCancelButton: true,
                confirmButtonColor: "#3085d6",
                cancelButtonColor: "#d33",
                confirmButtonText: "Yes, delete it!"
            }).then(result => {
                if (result.isConfirmed) {
                    axios
                        .delete("/leave/" + this.dataObject.id)
                        .then(res => {
                            Swal.fire("Deleted!", "", "success").then(
                                result => {
                                    this.$emit("delete");
                                }
                            );
                        })
                        .catch(err => {
                            console.warn(err);
                            Swal.fire("Error!", err.message, "error");
                        });
                }
            });
        }
    },
    computed: {
        defaultImage() {
            return this.dataObject.image_path
                ? "/storage/leaves/" + this.dataObject.image_path
                : "/img/no_image.jpg";
        }
    }
};
</script>
